using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.AI;

public class enemyController : MonoBehaviour
{
    public NavMeshAgent agent;

    public Transform player;

    public LayerMask whatIsGround, whatIsPlayer;


    // Patroling:
    public Vector3 walkPoint;
    bool walkPointSet;
    public float walkingRange;

    // Attacking 
    public float attackDelay;
    bool hasAttacked;

    // States
    public float sightRange, attackRange;
    public bool playerInSightR, playerInAttackR;

    private void awake()
    {
        player = GameObject.Find("Nolan").transform;
        agent = GetComponent<UnityEngine.AI.NavMeshAgent>();
    }

 

    // Update is called once per frame
    void Update()
    {
        playerInSightR = Physics.CheckSphere(transform.position, sightRange, whatIsPlayer);
        playerInAttackR = Physics.CheckSphere(transform.position, attackRange, whatIsPlayer);

        if (!playerInSightR && !playerInAttackR) Patroling();
        if (playerInSightR && !playerInAttackR) ChasePlayer();
        if (playerInSightR && playerInAttackR) AttackPlayer();
    }

    private void Patroling()
    {
        if (!walkPointSet) SearchWalkPoint();

        if (walkPointSet)
            agent.SetDestination(walkPoint);

        Vector3 distToWP = transform.position - walkPoint;

        // dest reached
        if (distToWP.magnitude < 1f)
            walkPointSet = false;

    }

    private void SearchWalkPoint()
    {
        // calc rand in Range point
        float randomZ = Random.Range(-walkingRange, walkingRange);
        float randomX = Random.Range(-walkingRange, walkingRange);

        walkPoint = new Vector3(transform.position.x + randomX, transform.position.y, transform.position.z + randomZ);

        if (Physics.Raycast(walkPoint, -transform.up, 2f, whatIsGround))
            walkPointSet = true; 
    }

    private void ChasePlayer()
    {
        agent.SetDestination(player.position);
    }

    private void AttackPlayer()
    {
        agent.SetDestination(transform.position);
        transform.LookAt(player);

        if (!hasAttacked)

            // attack Code..


            hasAttacked = true;
            Invoke(nameof(ResetAttack), attackDelay);
    }

    private void ResetAttack()
    {
        hasAttacked = false;
    }

    
}
